	section b
; these are the  keywords used with 'winx_*d2d' channels.
; the difference is that:
; qxl_offszet2 returns the 512 bytes sector number where the file can be found
; a different (slower) approach to reading the dirve is used: 512 bytes sectors only
	include	dev1_asm_incl_keys_err

	xref	rt_fp
	xref	rel_out
	xref	errbp
	xref	unlink
	xref	unlink2
	xref	swap_byte
	xref	fat_error
; v. 1.02 code copes with intel byte format (reversed byte order in word)
; v. 1.01 code made re-entrant & rommable


XJSR	macro	name
	xref	[name]		; - makes external jump
	JSR	[name]
	ENDM

sec_len	EQU	512		; here we have 512 byte "sectors"

***************************************************************************
*
*	offset=QXL_OFFSET #chan%[,start]
*
*
* this tries to find a QXLWIN file in $100 "sectors" of the cdr
*
* it returns the offset (i.e. nbr of 512 byte sectors from start), or:
* -1 no offet found in 256 sectors
* -2 problem when getting data from file
* if the offset is negative, then it is an intel partition
*
***************************************************************************

	xdef	qxl_offset2
qxl_offset2 MOVEQ	#0,D7
	XJSR	chan_num		; get channel ID
	BNE	rel_out		; oops
	MOVE.L	A0,A4
	CMP.L	A5,A3		; any more params?
	BEQ.S	no_param
	MOVE.W	$118,A2
	JSR	(A2)
	TST.L	D0
	BNE	rel_out
	ADDQ.L	#4,$58(A6)
	MOVE.L	(A6,A1.L),D7	; start sector
no_param	MOVE.L	#sec_len,D0
	XJSR	gu_achp		; get memory for 1 sector
	BNE	rel_out
	EXG	A0,A4
	MOVEQ	#-1,D3
	MOVE.L	#sec_len,D2	; nbr of bytes to get each time
	MOVE.L	D7,D6
	ADD.L	#$101,D7		; point $101 sectors further on
loop	MOVE.L	A4,A1		; this is to where we read
	MOVE.L	D6,D1
	MOVEQ	#$42,D0
	TRAP	#3		; (re) position here
	TST.L	D0		; ok?
	BNE.S	no_off2		; no, so pretend no offset found->...
lo2	MOVEQ	#3,D0		; now get sec_len bytes
	TRAP	#3
	TST.L	D0		; ok?
	BNE.S	no_off2		; no, so big problem - leave->...

got	CMP.L	#'QLWA',(A4)	; is this the QXL Win file?
	BEQ.S	found_it		; yes!->...
	CMP.L	#'LQAW',(A4)	; is it a swapped QXL WIN file?
	BNE.S	no_swap		; no->...
	NEG.L	D6		; yes so show it
	BRA.S	found_it
no_swap	ADDQ.L	#1,D6		; point next sector
	CMP.L	D6,D7		; reach the end of these sectors?
	BNE.S	loop		; not yet->...
no_off	MOVEQ	#-1,D6		; show no offset found!
found_it	MOVE.L	A4,A0
	XJSR	gu_rchp		; release mem
	MOVE.L	D6,D2		; return number as float
	JMP	rt_fp
no_off2	MOVEQ	#-2,D6		; end of file!
	BRA.S	found_it
	        

**************************************************************************************
*
* QXL_FAT2 :  fat = QXL_FAT2 (#chan%,offset,swap)
*
*
* this reads in the entire (!) FAT for the qxl drive
*
* chan% is the channel opened to the cdr drive: cdrx_*d8d
***************************************************************

	xdef	qxl_fat2
qxl_fat2
	XJSR	chan_num2 	; get channel ID into A4
	BNE	rel_out		; oops
	MOVE.W	$118,A2
	JSR	(A2)
	BNE	rel_out
	SUBQ.W	#2,D3		; there must have been 2 params
	BNE	errbp		; but there weren't
	MOVE.L	(A6,A1.L),D7	; D7 = offset (in sectors!)
	MOVE.L	4(A6,A1.L),D6	 ; D6 = swap indicator
	ADDQ.L	#8,$58(A6)	; reset math stack
	MOVE.L	#sec_len,D0
	XJSR	gu_achp		; get some mem now
	BNE	rel_out		; ooops
	EXG	A0,A4		; A4 = mem, A0 = channel ID
test	MOVE.L	D7,D1		; start of QXL file (sector number)
	MOVEQ	#-1,D3
	MOVEQ	#$42,D0
	TRAP	#3		; reposition at beginning of file
	TST.L	D0
	BNE	unlink2		; ooops->...
	MOVE.L	#512,D2		; read 512 bytes
	MOVE.L	A4,A1		; into here...
	MOVEQ	#3,D0
	TRAP	#3		; ... now
	TST.L	D0		; ok?
	BNE	unlink2		; oops->...
	MOVEQ	#-13,D0		; SIMULATE "PARITY ERROR" !!!
	CMP.W	D2,D1		; got the amount we wanted?
	BNE	unlink2		; no!
	CLR.L	D5
	MOVE.W	$22(A4),D5	; number of 512 byte sectors per cluster in QLD
	TST.W	D6		; is byte order swapped?
	BEQ.S	noswap1		; no ->...
	ROL.W	#8,D5		; yes, so swap as well
noswap1	CLR.L	D4
	MOVE.W	$34(A4),D4	; 1st root dir cluster = end of fat
	TST.W	D6
	BEQ.S	noswap2
	ROL.W	#8,D4
noswap2	MULU	D5,D4		; nbr of clusters to get x nbr of...
	MOVE.L	D4,D0		; ... secs per cluster = nbr of sectors to get
	LSL.L	#8,D0
	LSL.L	#1,D0		; * 512 = nbr of bytes to get
	MOVE.L	D0,D5
	ADD.L	#516,D0		; + 1 sector buffer + RECHP link
	EXG	A4,A0		; A4 = channel ID, A0 = memory
	XJSR	gu_rchp		; release OLD memory
	XJSR	gu_achp		; and get my memory
	BNE	rel_out		; oops
	LEA	$E0(A6),A1	; pointer to our link
	MOVE.W	$D2,A2		; link this mem into the rechp linked list
	JSR	(A2)		; now
	ADDQ.L	#4,A0		; cut out linkage area, for RECHP
	EXG	A4,A0		; A0 = channel ID, A4 = memory
	SUBQ.L	#1,D4		; prepare for DBF
	MOVE.L	A4,A1		; pointer to space for header & FAT

	MOVE.L	A4,A3		; start of mem
	ADD.L	D5,A3		; + length = end of mem
	MOVE.L	#sec_len,D2
	MOVE.L	D7,D5		; keep offset for putting into FAT
rdlp	MOVE.L	D7,D1		; 1rst sector number to get
	MOVEQ	#$42,D0
	TRAP	#3		; reposition at beginning of file
	TST.L	D0		; ok?
	BNE	unlink2		; no->....!
	MOVEQ	#3,D0		; get 512 bytes
	TRAP	#3
	TST.L	D0
	BNE	unlink2		; oops ->...
	ADDQ.L	#1,D7		; point next sector
	DBF	D4,rdlp		; and read it

	TST.W	D6		; do we have to swap?
	BEQ.S	noswap3		; no->...
	MOVE.L	A4,A0		; start of area
	BSR	swap_byte 	; swap bytes now....

noswap3	MOVE.L	D5,(A4)		; my offset at beginning of fat!!!
	MOVE.L	A4,D2
	JMP	rt_fp		; return address now

*****************************************************************
*
*
*        file = QXL_RFILE (#channel%, swap,fat,initial cluster,length_of_file)
*
*        read an entire file into memory !
*
*	file= address of file in memory, or 0 if error
*
*
*****************************************************************

	xdef qxl_rfile2
qxl_rfile2
	XJSR	chan_num2 	; get channel ID into A4
	MOVE.W	$118,A2
	JSR	(A2)		; get long ints
	TST.L	D0
	BNE	rel_out		; oops->...
	SUBQ.W	#4,D3		; there MUST be 4 ints
	BNE	errbp		; but there weren't
	ADD.L	#16,$58(A6)
	MOVE.L	(A6,A1.L),D4	; swap flag
	MOVE.L	4(A6,A1.L),A5	; fat pointer
	MOVE.L	8(A6,A1.L),D6	; initial cluster
	MOVE.L	12(A6,A1.L),D7	; length of this file (incl. header)
	CLR.L	D5
	MOVE.W	$22(A5),D5	; number of sectors per cluster in QLD
	MOVE.L	D5,D2
	LSL.L	#8,D2
	LSL.L	#1,D2		; number of bytes per cluster
	MOVE.L	D7,D0
	DIVS	D2,D0		; how often does this fit?
	ANDI.L	#$FFFF,D0
	ADDQ.L	#1,D0		; if rest
	MULU	D2,D0		; file occupies that many bytes in cluster size
	ADD.L	#sec_len+1,D0	; just to be on the safe side
	BCLR	#0,D0		; and make sure it's even
	XJSR	gu_achp		; get mem now
	BNE	rel_out		; oops!->...
	LEA	$E0(A6),A1	; pointer to our link
	MOVE.W	$D2,A2
	JSR	(A2)		; link this into heap
	ADDQ.L	#4,A0		; cut out linkage area (for RECHP)
	EXG	A0,A4		; a4 = mem, A0 =channel ID
	MOVE.L	A4,A1		; point to space for file
	MOVE.L	A4,A3
	ADD.L	D7,A3		; point to end of file
readloop	BSR.S	readclust 	; read cluster into (A1) now
	BNE	unlink2		; ooops
	TST.W	D6		; any more clusters to get?
	BEQ.S	rf_end		; no, finished->...
	CMP.L	#-1,D6		; this * should * never happen
	BEQ	fat_error 	; but it did (error in  FAT) ->...
	AND.L	#$FFFF,D1 	; just to make sure
	SUB.L	D1,D7
	BGT.S	readloop		; don't get more than file length, anyway!
rf_end	TST.L	D4		; deal with intel crap?
	BEQ.S	rf_end2		; no ->...
	MOVE.L	A4,A0		; point to memory
	BSR	swap_byte 	; swap everything
rf_end2	MOVE.L	A4,D2		; return memory
	JMP	rt_fp

**********************************************************
;
; readclust subroutine
; read the wished QXL cluster

; some assumptions:
; a "qxl" cluster is the cluster ("allocation unit") used by the QXL.WIN file
;
; a "qxl" cluster is made up of x sectors of 512 bytes.

; to read a "qxl" cluster, you do the following:
;  0  position at start of cluster
; as follows : qxl cluster * nbr of sectors per clster + offset to
; first sector where the qxl file lies

;  1  D2 = nbr of sectors in 1 qxl cluster
;  2  read nbr of sectors required for 1 cluster

rcregs	REG	D2-D5/A2

; this reads one QLD cluster into the memory pointed to by A1
; on entry			exit
;
; A0 = winx*d2d channel ID		stet
; A1 = memory for cluster		updated
; A5 = FAT			stet
; D1 = ????			???
; D5 = nbr of sectors per QXL cluster	stet
; D6.L = cluster to be read		NEXT corresponding cluster (or 0)
;
readclust MOVEM.L	rcregs,-(A7)
	MOVE.L	D6,D4		; cluster number
	MULU	D5,D4		; now sector number
	ADD.L	(A5),D4		; + sector offset to start of QXL file
	MOVE.L	#512,D2		; bytes to get
	SUBQ.W	#1,D5		; prepare for dbf
rclp1	MOVE.L	D4,D1		;
	MOVEQ	#-1,D3
	MOVEQ	#$42,D0
	TRAP	#3		; reposition here
	TST.L	D0		; ok?
	BNE.S	rc_out		; no! ->...
lo	MOVEQ	#3,D0		; now get D2 bytes
	TRAP	#3
	TST.L	D0		; ok?
	BNE.S	rc_out		; no, ->...
	ADDQ.L	#1,D4		; point to next sector in cluster
	DBF	D5,rclp1
; now calculate the next fat cluster
getnentry ADD.L	D6,D6		; FAT entry  = 1 word
	ADD.L	#$40,D6		; + fat header offset
	MOVE.W	(A5,D6.L),D0	; new FAT entry for this file
	MOVE.L	D0,D6		; make sure upper word is 0
	MOVEQ	#0,D0		;
rc_out	MOVEM.L	(A7)+,rcregs
p_out	RTS
	   
	end



difference between cdrx_*d8d (and normal) files and winx_*d2d files:

1 - in winx_*d2d file, the file position is given as 512 bytes sector
2 - in winx_*d2d file, reading one sector DOES NOT increase the file pos ptr,
    so you must set the file pos ptr explicitly before every call.
3 - you can't get more than 512 bytes from one read call.
